///////////////////////////////////////////////////////////////////////////////
// testDriverDlg.cpp : implementation file
//
// Copyright (c) 2005-2007 LAWICEL AB, Sweden

#include "stdafx.h"
#include "testDriver.h"
#include "testDriverDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Prototypes
void workThreadTransmit( void *pObject );

txstruct txObj; // For tranmsmit thread
char szDeviceArray[64][32];

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDriverDlg dialog

CTestDriverDlg::CTestDriverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestDriverDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestDriverDlg)
	m_EditStatus = _T("");
	m_MsgId = _T("");
	m_Data0 = _T("");
	m_Data1 = _T("");
	m_Data2 = _T("");
	m_Data3 = _T("");
	m_Data4 = _T("");
	m_Data5 = _T("");
	m_Data6 = _T("");
	m_Data7 = _T("");
	m_szOption2 = _T("");
	m_szOption1 = _T("");
	m_DriverID = _T("");
	m_Baudrate = _T("");
	m_EditBurstCount = _T("");
	m_sentFrames = _T("");
	m_receivedFrames = _T("");
	m_bTimeStamp = FALSE;
	m_checkNoFetch =  FALSE;
	m_bQueueReplace = FALSE;
	m_bBlockingMode = FALSE;
	m_bSlowMode = FALSE;
	m_bNoLocalSend = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_bOpen = false;
	m_drvHandle = 0;

	m_hIconOpen = AfxGetApp()->LoadIcon( IDC_TRAY_STATE0 );
	m_hIconClosed = AfxGetApp()->LoadIcon( IDC_TRAY_STATE1 );
}

CTestDriverDlg::~CTestDriverDlg()
{
	;
}

void CTestDriverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestDriverDlg)
	DDX_Control(pDX, IDC_COMBO_ADAPTERS, m_ctrlComboAdapters);
	DDX_Control(pDX, IDC_EDIT_STATUS, m_ctrlStatus);
	DDX_Control(pDX, IDC_EDIT_SELECTIV_FLAGS, m_ctrlSelectedFlags);
	DDX_Control(pDX, IDC_EDIT_SELECTIVE_ID, m_ctrlSelectedID);
	DDX_Control(pDX, IDC_CONECTION_STATE, m_ctrlConnectionState);
	DDX_Control(pDX, IDC_CHECK_RTR, m_ctrlCheckRTR);
	DDX_Control(pDX, IDC_CHECK_EXTENDED, m_ctrlExtended);
	DDX_Control(pDX, IDC_BUTTON_OPEN, m_ctrBtnOpen);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_EditStatus);
	DDX_Text(pDX, IDC_EDIT_MSGID, m_MsgId);
	DDX_Text(pDX, IDC_EDIT_DATABYTE0, m_Data0);
	DDX_Text(pDX, IDC_EDIT_DATABYTE1, m_Data1);
	DDX_Text(pDX, IDC_EDIT_DATABYTE2, m_Data2);
	DDX_Text(pDX, IDC_EDIT_DATABYTE3, m_Data3);
	DDX_Text(pDX, IDC_EDIT_DATABYTE4, m_Data4);
	DDX_Text(pDX, IDC_EDIT_DATABYTE5, m_Data5);
	DDX_Text(pDX, IDC_EDIT_DATABYTE6, m_Data6);
	DDX_Text(pDX, IDC_EDIT_DATABYTE7, m_Data7);
	DDX_Text(pDX, IDC_EDIT_SERIAL, m_DriverID);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE, m_Baudrate);
	DDX_Text(pDX, IDC_EDIT1, m_EditBurstCount);
	DDX_Text(pDX, IDC_STATIC_SEND_COUNT, m_sentFrames);
	DDX_Text(pDX, IDC_STATIC_RECEIVE_COUNT, m_receivedFrames);
	DDX_Check(pDX, IDC_CHECK_TIMESTAMP, m_bTimeStamp);
	DDX_Check(pDX, IDC_CHECK_NOFETCH, m_checkNoFetch);
	DDX_Check(pDX, IDC_CHECK_QUEUE_REPLACE, m_bQueueReplace);
	DDX_Check(pDX, IDC_CHECK_BLOCKING_MODE, m_bBlockingMode);
	DDX_Check(pDX, IDC_CHECK_SECURE_MODE, m_bSlowMode);
	DDX_Check(pDX, IDC_CHECK_LOCAL_SEND, m_bNoLocalSend);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestDriverDlg, CDialog)
	//{{AFX_MSG_MAP(CTestDriverDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEND_MSG, OnButtonSendMsg)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, OnButtonOpen)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_DATA, OnButtonClearData)
	ON_BN_CLICKED(IDC_BUTTON_GET_PROPERTIES, OnButtonGetProperties)
	ON_BN_CLICKED(IDC_BUTTON_GET_VERSION, OnButtonGetVersion)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_STATUS, OnButtonClearStatus)
	ON_BN_CLICKED(IDC_BUTTON_SEND_BURTS, OnButtonSendBurts)
	ON_BN_CLICKED(IDC_BUTTON_READFIRST, OnButtonReadfirst)
	ON_BN_CLICKED(IDC_CHECK_NOFETCH, OnCheckNofetch)
	ON_BN_CLICKED(IDC_BUTTON_BIG_BURST, OnButtonBigBurst)
	ON_BN_CLICKED(IDC_BUTTON_VIRTUAL_TEST, OnButtonVirtualTest)
	ON_BN_CLICKED(IDC_BUTTON_GET_ADAPTERS, OnButtonGetAdapters)
	ON_BN_CLICKED(IDC_BUTTON_TRANSFER, OnButtonTransfer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestDriverDlg message handlers

BOOL CTestDriverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if ( pSysMenu != NULL ) {
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if ( !strAboutMenu.IsEmpty()  ) {
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Get connected CANUSB adapters
	OnButtonGetAdapters();

	// Load registry data
	loadRegistryData();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


/////////////////////////////////////////////////////////////////////////////
//

void CTestDriverDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ( (nID & 0xFFF0) == IDM_ABOUTBOX ) {
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else {
		CDialog::OnSysCommand(nID, lParam);
	}
}


/////////////////////////////////////////////////////////////////////////////
//
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestDriverDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else {
		CDialog::OnPaint();
	}
}

//////////////////////////////////////////////////////////////////////////////
// OnQueryDragIcon
//
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
//

HCURSOR CTestDriverDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//////////////////////////////////////////////////////////////////////////////
// OnCancel
//

void CTestDriverDlg::OnCancel() 
{
	saveRegistryData();	
	CDialog::OnCancel();
}

//////////////////////////////////////////////////////////////////////////////
// OnButtonOpen
//

void CTestDriverDlg::OnButtonOpen() 
{
	unsigned char *p;
	unsigned char a,b,c,d;
	unsigned long flags = 0x00000000;


	CWaitCursor wait;

	UpdateData( true );

	flags = ( ( m_bTimeStamp ) ? CANUSB_FLAG_TIMESTAMP : 0 ) | 
			( ( m_bQueueReplace ) ? CANUSB_FLAG_QUEUE_REPLACE : 0 ) |
			( ( m_bBlockingMode ) ? CANUSB_FLAG_BLOCK : 0 ) |
			( ( m_bSlowMode ) ? CANUSB_FLAG_SLOW : 0 ) |
			( ( m_bNoLocalSend ) ? CANUSB_FLAG_NO_LOCAL_SEND : 0 );
	

	if ( m_bOpen ) {

		m_bOpen = false;

		if ( ERROR_CANUSB_OK != canusb_Flush( m_drvHandle, FLUSH_WAIT ) ) {
			// Failed to flush
			AfxMessageBox("Failed to flush output queue (timeout)." );
		}

		if ( ERROR_CANUSB_OK != canusb_Close( m_drvHandle ) ) {
			// Failed to close driver
			AfxMessageBox("Failed to close CANUSB interface." );
			return;
		}

		KillTimer( IDD_TIMER_READ );

		m_ctrBtnOpen.SetWindowText("Open");
		m_ctrlConnectionState.SetIcon( m_hIconClosed );
	}
	else {

		m_cntSentFrames = 0;
		m_cntReceivedFrames = 0;

		p = (unsigned char *)&flags;
		a = *p;
		b = *(p+1);
		c = *(p+2);
		d = *(p+3);
	
		CANMsg Msg;
		getDataValues( &Msg );

		if ( 0 >= ( m_drvHandle = canusb_Open( 
								(( strlen( m_DriverID ) ) ? (LPCTSTR)m_DriverID : NULL),
								(LPCTSTR)m_Baudrate,
								CANUSB_ACCEPTANCE_CODE_ALL,
								CANUSB_ACCEPTANCE_MASK_ALL,
								flags ) ) ) {
			// Failed to open driver
			AfxMessageBox("Failed to open CANUSB interface." );
			return;
		}

		m_ctrBtnOpen.SetWindowText("Close");
		m_ctrlConnectionState.SetIcon( m_hIconOpen );

		SetTimer( IDD_TIMER_READ, 10, NULL );
		m_bOpen = true;
	}
}

//////////////////////////////////////////////////////////////////////////////
// getDataValue
//

unsigned long CTestDriverDlg::getDataValue( const char *szData )
{
	unsigned long val;
	char *nstop;

	if ( ( NULL != strchr( szData, 'x' ) ) ||
			( NULL != strchr( szData, 'X' ) ) ) {
		val = strtoul( szData, &nstop, 16 );
	}
	else {
		val = strtoul( szData, &nstop, 10 );
	}

	return val;	
}


//////////////////////////////////////////////////////////////////////////////
// getAllData
//

bool CTestDriverDlg::getDataValues( CANMsg *pMsg )
{
	bool rv = false;
	unsigned char nData = 0;

	// Initialize message structure
	pMsg->flags = 0;
	pMsg->id = 0;
	pMsg->len = 0;
	pMsg->timestamp = 0;

	for ( int i=0; i<8; i++ ) {
		pMsg->data[ i ] = 0;
	}

	// Must have somewhere to store data
	if ( NULL == pMsg ) return rv;

	UpdateData( true );

	pMsg->id = getDataValue( m_MsgId );

	// Is the ID valid?
	if ( pMsg->id  > 0x1FFFFFFF ) return false;
	
	pMsg->data[ 7 ] = (unsigned char)getDataValue( m_Data7 );
	if ( m_Data7.GetLength() > 0 ) nData = 8;

	pMsg->data[ 6 ] = (unsigned char)getDataValue( m_Data6 );
	if ( ( 0 == nData ) && ( m_Data6.GetLength() > 0  ) ) nData = 7;
	
	pMsg->data[ 5 ] = (unsigned char)getDataValue( m_Data5 );
	if ( ( 0 == nData ) && ( m_Data5.GetLength() > 0  ) ) nData = 6;
	
	pMsg->data[ 4 ] = (unsigned char)getDataValue( m_Data4 );
	if ( ( 0 == nData ) && ( m_Data4.GetLength() > 0  ) ) nData = 5;
	
	pMsg->data[ 3 ] = (unsigned char)getDataValue( m_Data3 );
	if ( ( 0 == nData ) && ( m_Data3.GetLength() > 0  ) ) nData = 4;
	
	pMsg->data[ 2 ] = (unsigned char)getDataValue( m_Data2 );
	if ( ( 0 == nData ) && ( m_Data2.GetLength() > 0  ) ) nData = 3;
	
	pMsg->data[ 1 ] = (unsigned char)getDataValue( m_Data1 );
	if ( ( 0 == nData ) && ( m_Data1.GetLength() > 0  ) ) nData = 2;
	
	pMsg->data[ 0 ] = (unsigned char)getDataValue( m_Data0 );
	if ( ( 0 == nData ) && ( m_Data0.GetLength() > 0  ) ) nData = 1;
	
	pMsg->len = nData;

	// Extended message
	pMsg->flags = 0;

	if ( m_ctrlExtended.GetCheck() ) {
		pMsg->flags |= CANMSG_EXTENDED; 
	}

	// Remote Frame
	if ( m_ctrlCheckRTR.GetCheck() ) {
		pMsg->flags |= CANMSG_RTR; 	
	}
	
	// Write back data to dialog
	writeDataToDialog( pMsg );

	return rv;
}	

//////////////////////////////////////////////////////////////////////////////
// writeDataToDialog
//

void CTestDriverDlg::writeDataToDialog( CANMsg *pMsg )
{
	
	ultoa( pMsg->id, m_MsgId.GetBufferSetLength( 32 ), 16 );	
	m_MsgId = "0x" + m_MsgId; 

	
	// Extended flag
	if ( pMsg->flags & CANMSG_EXTENDED ) {
		m_ctrlExtended.SetCheck( 1 ); 
	}
	else {
		m_ctrlExtended.SetCheck( 0 );
	}

	if ( pMsg->id  > 0x7ff ) {
		m_ctrlExtended.SetCheck( 1 ); 
	}

	// RTR flag
	if ( pMsg->flags & CANMSG_RTR ) {
		m_ctrlCheckRTR.SetCheck( 1 ); 
	}
	else {
		m_ctrlCheckRTR.SetCheck( 0 );
	}

	// Clear all data fields
	m_Data0 = "";
	m_Data1 = "";
	m_Data2 = "";
	m_Data3 = "";
	m_Data4 = "";
	m_Data5 = "";
	m_Data6 = "";
	m_Data7 = "";


	if ( pMsg->len > 0 ) {
		m_Data0 = "";
		ultoa( pMsg->data[ 0 ], m_Data0.GetBufferSetLength( 32 ), 16 );	
		m_Data0 = "0x" + m_Data0; 
	}

	if ( pMsg->len > 1 ) {
		m_Data1 = "";
		ultoa( pMsg->data[ 1 ], m_Data1.GetBufferSetLength( 32 ), 16 );	
		m_Data1 = "0x" + m_Data1;
	}

	if ( pMsg->len > 2 ) {
		m_Data2 = "";
		ultoa( pMsg->data[ 2 ], m_Data2.GetBufferSetLength( 32 ), 16 );	
		m_Data2 = "0x" + m_Data2;
	}

	if ( pMsg->len > 3 ) {
		m_Data3 = "";
		ultoa( pMsg->data[ 3 ], m_Data3.GetBufferSetLength( 32 ), 16 );	
		m_Data3 = "0x" + m_Data3;
	}

	if ( pMsg->len > 4 ) {
		m_Data4 = "";
		ultoa( pMsg->data[ 4 ], m_Data4.GetBufferSetLength( 32 ), 16 );	
		m_Data4 = "0x" + m_Data4;
	}

	if ( pMsg->len > 5 ) {
		m_Data5 = "";
		ultoa( pMsg->data[ 5 ], m_Data5.GetBufferSetLength( 32 ), 16 );	
		m_Data5 = "0x" + m_Data5;
	}

	if ( pMsg->len > 6 ) {
		m_Data6 = "";
		ultoa( pMsg->data[ 6 ], m_Data6.GetBufferSetLength( 32 ), 16 );	
		m_Data6 = "0x" + m_Data6;
	}

	if ( pMsg->len > 7 ) {
		m_Data7 = "";
		ultoa( pMsg->data[ 7 ], m_Data7.GetBufferSetLength( 32 ), 16 );	
		m_Data7 = "0x" + m_Data7;
	}

	UpdateData( false );	
}



//////////////////////////////////////////////////////////////////////////////
// OnButtonSendMsg
//

void CTestDriverDlg::OnButtonSendMsg() 
{
	CANMsg msg;
  
	// Must be open
	if ( !m_bOpen ) return;

	UpdateData( true );
	getDataValues( &msg );
	if ( ERROR_CANUSB_OK !=  canusb_Write( m_drvHandle, &msg ) ) {
		AfxMessageBox("Failed to send message");
	}
	else {
		m_cntSentFrames++;
		ltoa( m_cntSentFrames, m_sentFrames.GetBuffer(80), 10 );
		UpdateData( false );
		msgToStatusList( &msg, false );
	}

	UpdateData( false );
}





//////////////////////////////////////////////////////////////////////////////
// OnButtonClearData
//

void CTestDriverDlg::OnButtonClearData() 
{
	m_Data0 = "";
	m_Data1 = "";
	m_Data2 = "";
	m_Data3 = "";
	m_Data4 = "";
	m_Data5 = "";
	m_Data6 = "";
	m_Data7 = "";
	UpdateData( false );
}


///////////////////////////////////////////////////////////////////////////////
//	OnButtonGetProperties
//
//

void CTestDriverDlg::OnButtonGetProperties() 
{
	unsigned char status;
	char buf[ 80 ];

	// Must be open
	if ( !m_bOpen ) return;
	
	status = canusb_Status( m_drvHandle );

	sprintf( buf, "status=%02X\r\n", status );
	UpdateData( true );
	m_EditStatus = buf + m_EditStatus;
	UpdateData( false );
}


///////////////////////////////////////////////////////////////////////////////
//	OnButtonGetVersion
//
//

void CTestDriverDlg::OnButtonGetVersion() 
{
	char buf[ 512 ];
	char szVersion[ 255 ];

	// Must be open
	if ( !m_bOpen ) return;

	if ( ERROR_CANUSB_OK != canusb_VersionInfo( m_drvHandle, szVersion ) ) {
		AfxMessageBox("Failed to get version information");
		return;
	}

	sprintf( buf, "version=%s\r\n", szVersion );
	UpdateData( true );
	m_EditStatus = buf + m_EditStatus;
	UpdateData( false );
	
}


///////////////////////////////////////////////////////////////////////////////
//	OnTimer
//
//

void CTestDriverDlg::OnTimer(UINT nIDEvent) 
{
	CANMsg msg;
	unsigned char cnt = 0;
 
	while ( m_bOpen && 
			( cnt < 10 ) &&
			!m_checkNoFetch && 
			( ERROR_CANUSB_OK == canusb_Read( m_drvHandle, &msg ) ) ) {
		m_cntReceivedFrames++;
		msgToStatusList( &msg, true );
		cnt++;
	}

	CDialog::OnTimer(nIDEvent);
}


///////////////////////////////////////////////////////////////////////////////
//	msgToStatusList
//
//

void CTestDriverDlg::msgToStatusList( CANMsg *pmsg, bool bDirOut )
{
	int i;
	char buf[ 256 ], wrkbuf[ 10 ];;
	char cExtended;
	char cRTR;

	cExtended = 'S';
	if ( pmsg->flags & CANMSG_EXTENDED ) {
		cExtended = 'E';
	}

	cRTR = ' ';
	if ( pmsg->flags & CANMSG_RTR ) {
		cRTR = 'R';
	}

	if ( bDirOut ) {
		sprintf( buf, "<- %c%c id = %08X timestamp = %08X len = %d data =", cExtended, cRTR, pmsg->id, pmsg->timestamp, pmsg->len );
	}
	else {
		sprintf( buf, "-> %c%c id = %08X timestamp = %08X len = %d data =", cExtended, cRTR, pmsg->id, pmsg->timestamp, pmsg->len );
	}
	
	for ( i=0; i<pmsg->len; i++ ) {
		sprintf( wrkbuf, "%02x ", pmsg->data[ i ] );
		strcat( buf, wrkbuf );
	}

	strcat( buf, "\r\n" );

	UpdateData( true );
	ltoa( m_cntReceivedFrames, m_receivedFrames.GetBuffer(80), 10 );
	m_EditStatus = buf + m_EditStatus;
	UpdateData( false );
}

///////////////////////////////////////////////////////////////////////////////
//	OnButtonClearStatus
//
//

void CTestDriverDlg::OnButtonClearStatus() 
{
	m_EditStatus = "";
	UpdateData( false );
}

///////////////////////////////////////////////////////////////////////////////
//	OnButtonSendBurts
//
//

void CTestDriverDlg::OnButtonSendBurts() 
{
	char buf[512];
	CANMsg msg;
	long cnt = 1;

	// Must be open
	if ( !m_bOpen ) return;

	UpdateData( true );
	getDataValues( &msg );
	cnt = getDataValue( m_EditBurstCount );
	int rv;
	for ( long i=0; i<cnt; i++ ) {

		if ( ERROR_CANUSB_OK != ( rv = canusb_Write( m_drvHandle, &msg ) ) ) {
			if ( ERROR_CANUSB_TX_FIFO_FULL == rv ) {
				AfxMessageBox("Failed to send message - Transmit queue full.");
			}
			else {
				AfxMessageBox("Failed to send message");
			}
			return;
		}
		
	}

	UpdateData( true );
	m_cntSentFrames += cnt;
	ltoa( m_cntSentFrames, m_sentFrames.GetBuffer(80), 10 );
	sprintf( buf, "Burst sent of message above : cnt = %d\r\n", cnt );
	m_EditStatus = buf + m_EditStatus;
	UpdateData( false );
	msgToStatusList( &msg, false );
}

///////////////////////////////////////////////////////////////////////////////
//	OnButtonBigBurst
//
//

void CTestDriverDlg::OnButtonBigBurst() 
{
	char buf[512];
	CANMsg msg;
	long cnt = 1;

	CWaitCursor cw;
	
	// Must be open
	if ( !m_bOpen ) return;

	UpdateData( true );
	getDataValues( &msg );
	cnt = 0xffff;
	int rv;
	for ( long i=0; i<cnt; i++ ) {
		while ( ERROR_CANUSB_TX_FIFO_FULL == ( rv = canusb_Write( m_drvHandle, &msg ) ) ) {
			Sleep( 1 );
		}
	}


	UpdateData( true );
	m_cntSentFrames += cnt;
	ltoa( m_cntSentFrames, m_sentFrames.GetBuffer(80), 10 );
	sprintf( buf, "Burst sent of message above : cnt = %d\r\n", cnt );
	m_EditStatus = buf + m_EditStatus;
	UpdateData( false );
	msgToStatusList( &msg, false );
	
}

/////////////////////////////////////////////////////////////////////////////
// OnButtonReadfirst
//

void CTestDriverDlg::OnButtonReadfirst() 
{
	char bufId[32], bufFlags[32];
	CANMsg msg;

	UpdateData( true );	// Get dialog data
	m_ctrlSelectedID.GetWindowText( bufId,  sizeof( bufId ) );
	m_ctrlSelectedFlags.GetWindowText( bufFlags, sizeof( bufFlags ) );

	if ( m_bOpen && 
			( ERROR_CANUSB_OK == canusb_ReadFirst( m_drvHandle, 
														getDataValue( bufId ),
														(unsigned char)getDataValue( bufFlags ),
														&msg ) ) ) {
		m_cntReceivedFrames++;
		msgToStatusList( &msg, true );
	}
}

/////////////////////////////////////////////////////////////////////////////
// OnCheckNofetch
//

void CTestDriverDlg::OnCheckNofetch() 
{
	UpdateData( true );	// Get dialog data	
}


/////////////////////////////////////////////////////////////////////////////
// OnButtonVirtualTest
//
// Opens a second virtual channel to an open interface
//

void CTestDriverDlg::OnButtonVirtualTest() 
{
	int i;
	long h;
	unsigned char *p;
	unsigned char a,b,c,d;
	unsigned long flags = 0x00000000;
	HANDLE hTreadTransmit;
	CANMsg msg;

	// Must be open
	if ( !m_bOpen ) {
		AfxMessageBox("Must be open!");
		return;
	}
	
	UpdateData( true );	// Get dialog data

	CWaitCursor wait;


	flags = ( ( m_bTimeStamp ) ? CANUSB_FLAG_TIMESTAMP : 0 ) | 
			( ( m_bQueueReplace ) ? CANUSB_FLAG_QUEUE_REPLACE : 0 ) |
			( ( m_bBlockingMode ) ? CANUSB_FLAG_BLOCK : 0 ) |
			( ( m_bSlowMode ) ? CANUSB_FLAG_SLOW : 0 ) |
			( ( m_bNoLocalSend ) ? CANUSB_FLAG_NO_LOCAL_SEND : 0 );
	

	p = (unsigned char *)&flags;
	a = *p;
	b = *(p+1);
	c = *(p+2);
	d = *(p+3);

	// Open channel
	if ( 0 >= ( h = canusb_Open( (( strlen( m_DriverID ) ) ? (LPCTSTR)m_DriverID : NULL),
								(LPCTSTR)m_Baudrate,
								CANUSB_ACCEPTANCE_CODE_ALL,
								CANUSB_ACCEPTANCE_MASK_ALL,
								flags ) ) ) {
		// Failed to open driver
		AfxMessageBox("Failed to open CANUSB interface." );
		return;
	}

	getDataValues( &msg );

	// Send some message
	for ( i=0; i<10; i++ ) {
		if ( ERROR_CANUSB_OK !=  canusb_Write( h, &msg ) ) {
			AfxMessageBox("Failed to send message");
		}
	}



	//*************************************************************
	//
	//							N E W	T H R E A D
	//
	//*************************************************************

	txObj.bRun = true;
	*txObj.log = 0;
	txObj.flags = CANUSB_FLAG_TIMESTAMP;
	strcpy( txObj.szDevice, m_DriverID );
	strcpy(txObj.szSpeed, m_Baudrate );

	// Start write thread 
	DWORD ThreadId;
	if ( NULL == ( hTreadTransmit = 
					CreateThread(	NULL,
									0,
									(LPTHREAD_START_ROUTINE) workThreadTransmit,
									&txObj,
									0,
									&ThreadId ) ) ) { 
		// Failure
		return;
	}

	// Close the channel again
	if ( ERROR_CANUSB_OK != canusb_Close( h ) ) {
		// Failed to close driver
		AfxMessageBox("Failed to close CANUSB interface." );
		return;
	}

	
}

/////////////////////////////////////////////////////////////////////////////
// loadRegistryData
//

void CTestDriverDlg::loadRegistryData()	
{
	HKEY hk;
	DWORD val;
	DWORD lv;
	DWORD type;
	char nDataBytes = 0;
	unsigned char buf[ 512 ];
	
	if ( ERROR_SUCCESS == RegOpenKeyEx(	HKEY_LOCAL_MACHINE,
											"software\\lawicel\\testDriver",
											NULL,
											KEY_READ,
											&hk ) ) {
				
		// * * * canid * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"canid",
												NULL,
												&type,
												(unsigned char *)&val,
												&lv ) ) {
			
		}
		else {
			val = 0;
		}

		ultoa( val, m_MsgId.GetBufferSetLength( 32 ), 16 );
		m_MsgId = "0x" + m_MsgId;

		// * * * CAN Data bytes * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
													"nDataBytes",
													NULL,
													&type,
													(unsigned char *)&val,
													&lv ) ) {
			nDataBytes = (char)val;
		}

		// * * * Data 0 * * *
		if ( nDataBytes > 0 ) {
			lv = sizeof( DWORD );
			if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
														"data0",
														NULL,
														&type,
														(unsigned char *)&val,
														&lv ) ) {
				ultoa( val, m_Data0.GetBufferSetLength( 32 ), 16 );
				m_Data0 = "0x" + m_Data0;
			}
			else {
				m_Data0 = "";
			}
		}

		// * * * Data 1 * * *
		if ( nDataBytes > 1 ) {
			lv = sizeof( DWORD );
			if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
														"data1",
														NULL,
														&type,
														(unsigned char *)&val,
																							&lv ) ) {
				ultoa( val, m_Data1.GetBufferSetLength( 32 ), 16 );
				m_Data1 = "0x" + m_Data1;
			}
			else {
				m_Data1 = "";
			}
		}

		// * * * Data 2 * * *
		if ( nDataBytes > 2 ) {
			lv = sizeof( DWORD );
			if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
														"data2",
														NULL,
														&type,
														(unsigned char *)&val,
														&lv ) ) {
				ultoa( val, m_Data2.GetBufferSetLength( 32 ), 16 );
				m_Data2 = "0x" + m_Data2;
			}
			else {
				m_Data2 = "";
			}
		}

		// * * * Data 3 * * *
		if ( nDataBytes > 3 ) {
			lv = sizeof( DWORD );
			if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
														"data3",
														NULL,
														&type,
														(unsigned char *)&val,
														&lv ) ) {
				ultoa( val, m_Data3.GetBufferSetLength( 32 ), 16 );
				m_Data3 = "0x" + m_Data3;
			}
			else {
				m_Data3 = "";
			}
		}

		// * * * Data 4 * * *
		if ( nDataBytes > 4 ) {
			lv = sizeof( DWORD );
			if ( ERROR_SUCCESS == RegQueryValueEx(	hk,																							"data4",
														NULL,
														&type,
														(unsigned char *)&val,
														&lv ) ) {
				ultoa( val, m_Data4.GetBufferSetLength( 32 ), 16 );
				m_Data4 = "0x" + m_Data4;
			}
			else {
				m_Data4 = "";
			}
		}

		// * * * Data 5 * * *
		if ( nDataBytes > 5 ) {
			lv = sizeof( DWORD );
			if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
														"data5",
														NULL,
														&type,
														(unsigned char *)&val,
														&lv ) ) {
				ultoa( val, m_Data5.GetBufferSetLength( 32 ), 16 );
				m_Data5 = "0x" + m_Data5;
			}
			else {
				m_Data5 = "";
			}
		}

		// * * * Data 6 * * *
		if ( nDataBytes > 6 ) {
			lv = sizeof( DWORD );
			if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
														"data6",
														NULL,
														&type,
														(unsigned char *)&val,
														&lv ) ) {
				ultoa( val, m_Data6.GetBufferSetLength( 32 ), 16 );
				m_Data6 = "0x" + m_Data6;
			}
			else {
				m_Data6 = "";
			}
		}

		// * * * Data 7 * * *
		if ( nDataBytes > 7 ) {
			lv = sizeof( DWORD );
			if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
														"data7",
														NULL,
														&type,
														(unsigned char *)&val,
														&lv ) ) {
				ultoa( val, m_Data7.GetBufferSetLength( 32 ), 16 );
				m_Data7 = "0x" + m_Data7;
			}
			else {
				m_Data7 = "";
			}
		}

		// * * * extended id check box * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"bExtended",
												NULL,
												&type,
												(unsigned char *)&val,
												&lv ) ) {
			if ( val )  m_ctrlExtended.SetCheck( 1 ) ;
		}		 

		// * * * RTR check box * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"bRTR",
												NULL,
												&type,
												(unsigned char *)&val,
												&lv ) ) {
			if ( val )  m_ctrlCheckRTR.SetCheck( 1 ) ;
		}

 
		// * * * Timestamp check box * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"bTimeStamp",
												NULL,
												&type,
												(unsigned char *)&val,
												&lv ) ) {
			if ( val )  m_bTimeStamp = 1;
		}

		// * * * Queue replace check box * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"bQueueReplace",
												NULL,
												&type,
												(unsigned char *)&val,
												&lv ) ) {
			if ( val )  m_bQueueReplace = 1;
		}


		// * * * Blocking mode check box * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"bBlockingMode",
												NULL,
												&type,
												(unsigned char *)&val,
												&lv ) ) {
			if ( val )  m_bBlockingMode = 1;
		}

		// * * * Slow mode check box * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"bSlowMode",
												NULL,
												&type,
												(unsigned char *)&val,
												&lv ) ) {
			if ( val )  m_bSlowMode = 1;
		}

		// * * * No local send check box * * *
		lv = sizeof( DWORD );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"bNoLocalSend",
												NULL,
												&type,
												(unsigned char *)&val,
												&lv ) ) {
			if ( val )  m_bNoLocalSend = 1;
		}

		// * * * Option1 * * *
		lv = sizeof( buf );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"Option1",
												NULL,
												&type,
												buf,
												&lv ) ) {
			m_szOption1 = buf;
		}

		// * * * Option1 * * *
		lv = sizeof( buf );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"Option2",
												NULL,
												&type,
												buf,
												&lv ) ) {
			m_szOption2 = buf;
		}

		// * * * id * * *
		lv = sizeof( buf );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"DriverID",
												NULL,
												&type,
												buf,
												&lv ) ) {
			m_DriverID = buf;
		}

		// * * * baudrate * * *
		lv = sizeof( buf );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"Baudrate",
												NULL,
												&type,
												buf,
												&lv ) ) {
			m_Baudrate = buf;
		}

		// * * * burst count * * *
		lv = sizeof( buf );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"BurstCount",
												NULL,
												&type,
												buf,
												&lv ) ) {
			m_EditBurstCount = buf;
		}


		
		// * * * SelectedId * * * 
		lv = sizeof( buf );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"SelectedId",
												NULL,
												&type,
												buf,
												&lv ) ) {

			m_ctrlSelectedID.SetWindowText( (char *)buf );
		}
		
		
		// * * * SelectedFlags * * * 
		lv = sizeof( buf );
		if ( ERROR_SUCCESS == RegQueryValueEx(	hk,
												"SelectedFlags",
												NULL,
												&type,
												buf,
												&lv ) ) {

			m_ctrlSelectedFlags.SetWindowText( (char *)buf );
		}
		 	
		RegCloseKey( hk );

	}

	UpdateData( false );
}


//////////////////////////////////////////////////////////////////////////////
// saveRegistryData
//
// Write persistant data to the registry
//

void CTestDriverDlg::saveRegistryData()
{
	CANMsg canmsg;
	HKEY hk;
	char buf[ 512 ];


	// Get screen data
	getDataValues( &canmsg );

	
	if ( ERROR_SUCCESS == RegOpenKeyEx(	HKEY_LOCAL_MACHINE,
											"software",
											NULL,
											KEY_ALL_ACCESS,
											&hk ) )
	{
		
		HKEY hk_preopt;
		DWORD predisp;
 
		RegCreateKeyEx( hk, "lawicel", 0L, 
							REG_OPTION_NON_VOLATILE, 
							NULL,
							KEY_ALL_ACCESS,
							NULL,
							&hk_preopt,
							&predisp );
		
		
		
		HKEY hk_opt;
		DWORD disp;
 
		RegCreateKeyEx( hk_preopt, "testDriver", 0L, 
							REG_OPTION_NON_VOLATILE, 
							NULL,
							KEY_ALL_ACCESS,
							NULL,
							&hk_opt,
							&disp );
		
		DWORD val;

		// CAN id
		val =  canmsg.id;
		RegSetValueEx( hk_opt,
						"canid",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )		
						);

		// CAN Data bytes
		for ( int i = 0; i< 8; i++ ) {
			val =  canmsg.data[ i ];
			sprintf( (char *)buf, "data%i", i );
			RegSetValueEx( hk_opt,
						(const char *)buf,
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )		
						);	
		}

		// # of data bytes
		val =  canmsg.len;
		RegSetValueEx( hk_opt,
						"nDataBytes",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )	);

		// Option1
		strcpy( buf, m_szOption1 );
		RegSetValueEx( hk_opt,
						"option1",
						NULL,
						REG_SZ,
						(const unsigned char *)buf,
						sizeof( val )	);

		// Option2
		strcpy( buf, m_szOption2 );
		RegSetValueEx( hk_opt,
						"option2",
						NULL,
						REG_SZ,
						(const unsigned char *)buf,
						sizeof( val )	);

		// extended id check box
		val =  m_ctrlExtended.GetCheck();
		RegSetValueEx( hk_opt,
						"bExtended",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )	);

		// RTR check box
		val =  m_ctrlCheckRTR.GetCheck();
		RegSetValueEx( hk_opt,
						"bRTR",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )	);

		// Timestamp check box
		val =  m_bTimeStamp;
		RegSetValueEx( hk_opt,
						"bTimeStamp",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )	);

		// QueueReplace check box
		val =  m_bQueueReplace;
		RegSetValueEx( hk_opt,
						"bQueueReplace",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )	);


		// Blocking mode check box
		val =  m_bBlockingMode;
		RegSetValueEx( hk_opt,
						"bBlockingMode",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )	);

		// Slow mode check box
		val =  m_bSlowMode;
		RegSetValueEx( hk_opt,
						"bSlowMode",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )	);

		// Local send check box
		val =  m_bNoLocalSend;
		RegSetValueEx( hk_opt,
						"bNoLocalSend",
						NULL,
						REG_DWORD,
						(CONST BYTE *)&val,
						sizeof( val )	);

		// DriverID
		strcpy( buf, m_DriverID );
		RegSetValueEx( hk_opt,
						"DriverID",
						NULL,
						REG_SZ,
						(const unsigned char *)buf,
						strlen( buf )	);

		// Baudrate
		strcpy( buf, m_Baudrate );
		RegSetValueEx( hk_opt,
						"Baudrate",
						NULL,
						REG_SZ,
						(const unsigned char *)buf,
						strlen( buf )	);

		// BurstCount
		strcpy( buf, m_EditBurstCount );
		RegSetValueEx( hk_opt,
						"BurstCount",
						NULL,
						REG_SZ,
						(const unsigned char *)buf,
						strlen( buf )	);
		

		m_ctrlSelectedID.GetWindowText( buf,  sizeof( buf ) );
		RegSetValueEx( hk_opt,
						"SelectedId",
						NULL,
						REG_SZ,
						(const unsigned char *)buf,
						strlen( buf )	);
		
		m_ctrlSelectedFlags.GetWindowText( buf, sizeof( buf ) );
		RegSetValueEx( hk_opt,
						"SelectedFlags",
						NULL,
						REG_SZ,
						(const unsigned char *)buf,
						strlen( buf )	);
	 

		RegCloseKey( hk );
		RegCloseKey( hk_opt ); 
		RegCloseKey( hk_preopt ); 
	}
}


///////////////////////////////////////////////////////////////////////////////
//	workThreadTransmit
//	

void workThreadTransmit( void *pObject )
{
	int i,j;
	DWORD errorCode = 0;
	int drvhandle, rv;
	txstruct *ptxObj = (txstruct *)pObject;
	CANMsg msg;

	if ( 0 >= ( drvhandle = canusb_Open( ptxObj->szDevice,
											ptxObj->szSpeed,
											CANUSB_ACCEPTANCE_CODE_ALL,
											CANUSB_ACCEPTANCE_MASK_ALL,
											ptxObj->flags ) ) ) {
		ExitThread( -1 );	 
	}


	for ( j=0; j<8; j++ ) {
		
		for ( i=0; i<100; i++ ) {

			msg.id = 111;
			msg.flags = 0;
			msg.len = j;
			msg.data[0] = 1;
			msg.data[1] = 2;
			msg.data[2] = 3;
			msg.data[3] = 4;
			msg.data[4] = 5;
			msg.data[5] = 6;
			msg.data[6] = i & 0xff;
			msg.data[7] = i >> 8;
		
			if ( ERROR_CANUSB_OK !=  ( rv = canusb_Write( drvhandle, &msg ) ) ) {
				canusb_Close( drvhandle );
				ExitThread( -3 );
			}

		}
	}


	if ( ERROR_CANUSB_OK != ( rv = canusb_Flush( drvhandle, 0 ) ) ) {
		canusb_Close( drvhandle );
		ExitThread( -4 );
	}

	if ( ERROR_CANUSB_OK != ( rv = canusb_Close( drvhandle ) ) ) {
		ExitThread( -2 );
	}

	ExitThread( errorCode );
}




///////////////////////////////////////////////////////////////////////////////
//	OnButtonGetAdapters
//

void CTestDriverDlg::OnButtonGetAdapters() 
{
	int cnt, i;
	char szAdapter[32];
	CString str;
	
	// Clear the Combo
	m_ctrlComboAdapters.Clear();
	cnt = m_ctrlComboAdapters.GetCount();
	while (cnt) {
		m_ctrlComboAdapters.DeleteString( 0 );
		cnt = m_ctrlComboAdapters.GetCount();
	}

	// Fill the box with serial numbers if there are any
	// adapters avaiable
	if ( ( cnt = canusb_getFirstAdapter( szAdapter, sizeof( szAdapter ) ) ) > 0 ) {
		str = szAdapter;
		m_ctrlComboAdapters.AddString( str );
		for ( i=1; i<cnt; i++ ) {
			canusb_getNextAdapter( szAdapter, sizeof( szAdapter ) );
			str = szAdapter;
			m_ctrlComboAdapters.AddString( str );
		}

		// Select the first
		m_ctrlComboAdapters.SetCurSel( 0 );
	}
}


///////////////////////////////////////////////////////////////////////////////
//	OnButtonTransfer
//

void CTestDriverDlg::OnButtonTransfer() 
{
	if ( -1 != m_ctrlComboAdapters.GetCurSel() ) {
		m_ctrlComboAdapters.GetLBText( m_ctrlComboAdapters.GetCurSel(), m_DriverID );
		UpdateData( false );
	}
}
